TZO Perl client v2


TZO DDNS client and daemon/service, for systems equipped with Perl 5. 


HISTORY
See HISTORY file for updates

What is TZO?

TZO offers Domain Registration Services and Dynamic Domain 
Registration Service (Official Registrar), SMTP Mail 
Store and Forward, and Web Hosting options for users with 
Static or Dynamic IP Addresses(you can host multiple virtual 
domains with your one IP Address). TZO also allows for DNS 
Hosting/Parking Services for Cable and DSL users as well as 
standard ethernet and PPP. Host Private Domains on your Linux
Server with a Dynamic IP Address. Private Domains are less
that $60 per year if your domain is already registered! 
Ask about our relay options! mailto:<support@tzo.com>.


Basic Install

NOTE: This client is supported on Apple OS X as a UNIX application. Additional
 information for running TZO on OS X can be found in the file, README.osx.

STEP 1
Download the TZO Perl client. If you are reading this, you may have already
done this (this README is also visible on the TZO website).

It is important to unpack this file on the system you plan to install onto,
NOT on "another computer" (such as Windows) where decompression utilities
(WinZip, unStuffit) somtimes lose critical information from the archive.

To that end, it is sometimes easier to download using a command-line tool
-- such as wget or curl (or ftp) -- instead of a webbrowser.
An example wget download follows:
prompt>$  wget ftp://ftp.tzo.com/URL-of-this-file

With a graphical desktop environment, you can copy the URL from a web broswer
onto the Clipboard, and then that URL after a command, in your Terminal/shell.

STEP 2
Assuming the archive is in a suitable temporary location (such as
/home/your-name/), uncompress the archive:

Linux:
[user@host user]$ tar -xzvf  tzov2.tar.gz

Solaris:
bash-2.03# gunzip tzov2.tar.gz
bash-2.03# tar xvf tzov2.tar

OSX:
[user@host user]$ tar -xzvf  tzov2.tar.gz

You may use another program to decompress the archive, but some such programs
do not recover file permissions so this is not advised. 


STEP 3
'sudo', or login as root. For OS X users, the README.osx file outlines how
to first "enable root logins".


STEP 4
From the directory the files were extracted to, run the "perl ./install.pl".


STEP 5
Follow the prompts requested by install.pl
If you make a mistake, you can control-C to terminate the install. You can
re-run install.pl at any time, and it will recover any previously
saved settings.

The most commonly asked questions here are:
"Do I want to use a gateway?" (You do, if you want TZO to detect the IP address
    assigned by your ISP)
"What ip-check interval do I select?" (Anything between 1-min and 10-min is
    most common. Checking IPs uses some bandwidth - 1-min may be too much for
    dialup servers. On the other hand, if you only check once per 30 minutes 
    then if your IP changes it could be 29 minutes before it is updated.)
"What 'cache type' do I select?". ( It is best to select the cache type
    that most closely matches your connection type. This really does not
	affect speed, but it does impact how long DNS servers will cache your 
	DNS record. DNS caching is beneficial in that your domain lookups go
	faster, but if your IP address changes then your website may be
	unreachable for a short time, until the old cached DNS records are
	retired. Note: Some DNS servers ignore DNS cache attributes, effectively
	overriding this value. If you're not sure what all of this means, just 
	match the Connection Type. )
	


STEP 6
REDHAT LINUX SYSTEMS ONLY:
TZO is configured to run upon next reboot, as part of INIT. You should still
test your client configuration however (see below).

All other UNIX-related systems:
You can startup TZO manually (as root) using 'tzo -o -v'.

You should see some output such as your domain name and expiration date. This
indicates a successful signon -- you can now tell TZO to run as a daemon, using "tzo -d".

If you do these steps as a nonroot user, you will get "undefined subroutine" errors.

TZO also saves a text logfile as /var/log/tzousage.log

FOR OS X SYSTEMS ONLY:
Tzo starts as an INIT script same as Redhat. All this means is TZO will run
when you boot, even if no one has logged into a desktop.

FOR OTHER UNIX, AND NON-REDHAT LINUX:

After verifying your configuration using "tzo -o -v", and running it as a 
daemon (using tzo -d), you probably want to ensure TZO comes up at the next
system reboot:

Edit your system's rc.local file, usually under /etc/init.d/, to contain:
tzo -d

Bug reports have been filed against the TZO Perl client to note that support
for installation on "other" Linux is needed. This will be addressed in a
future release.

This completes installation.

-------------------------------
Examples and usage for tzov2.pl

--- Command line Options and Flags

--- Options
 -o             : signon your Domain Name
 -f             : signoff your Domain Name
 -d			 : daemonize - run in the background
 -q			 : Quit the daemon process and signoff

--- Flags

 -h             : give usage.
 -v             : give some informative output.
 -e <TZO email> : specify TZO email (default: $TZOEMAIL)
 -n <TZO name>  : specify TZO name (default: $TZONAME)
 -k <TZO key>   : specify your TZO key (default: $TZOKEY)
 -i <interface> : get ip address from <interface>
 -I <ipaddress> : use <ipaddress>
 -c <ctype>     : specify connection type (default: $CTYPE)

 CTYPE (Connection Types)
   1   Dial-up Modem
   2   Cable Modem
   3   LAN (Local Area Network)
   4   ADSL, HDSL, xDSL
   5   America Online Dial-up
   6   Other Connection Type
   7   Static IP Address

********************

Now to activate the service run the following commands from the console

[user@host user]# tzo -o  # this signs on your domain with no output
[user@host user]# tzo -ov # this signs on your domain with output

[user@host user]# tzo -f  # this signs off your domain with no output
[user@host user]# tzo -fv # this signs off your domain with output

[user@host user]# tzo -d  # this signs on your domain and continues 
							to run in the background
[user@host user]# tzo -q  # this signs off your domain and kills the daemon 

To START the daemon from init manually for the TZO DDNS Service.

[user@host user]# /etc/rc.d/init.d/tzod start

or

[user@host user]# /etc/init.d/tzod start

To STOP the daemon from init manually for the TZO DDNS Service.

[user@host user]# /etc/rc.d/init.d/tzod stop

or

[user@host user]# /etc/init.d/tzod stop

################################
BASIC TROUBLESHOOTING

1) Be sure your local DNS is working. Local DNS is not the same as the DNS
provided by TZO... in order to sign-on to TZO at all, your server needs to 
resolve URLS like 'http://rh.tzo.com'. If your server cannot do a
'dig rh.tzo.com', you have a local DNS problem to resolve first.

2) Be sure your routing tables are correct. On the system running TZO,
attempt the following: ping www.google.com

If the domain resolves to an IP, and that IP responds to the ping, you can
be reasonably sure your routing is OK.
IMPORTANT:
Note that some internet sites do not respond to PING (including tzo.com,
and microsoft.com). If in doubt, try a second ping from another system
that you know DNS is working on, and ping known pingable servers.
 
If the domain resolves to an IP, but ping seems to hang (or not respond)
then you have routing issues to resolve.

3) Be certain TZO is receiving your DNS updates:
What does 'dig' or 'nslookup' indicate your DNS IP?
Does that IP address match your gateway/router? You can test this by
making a web connection to: http://echo.tzo.com:21333

You must make the connection from your TZO-equipped system... tellnet or
ssh into that system. To invoke the URL, most UNIX systems come with
basic command-line http clients such as:  links, lynx, wget, w3m, curl, etc.

4) If your TZO address matches your correct WAN address, it's likely your
problem is internal routing from the router, or maybe an internet service
you're running is not listening for the right IP address or port.

If your website "works by IP address", be sure to test with both your
internal (private) LAN IP, and also the external (WAN) IP, the number of
which you can obtain from the 'echo' server in step #3.

If both your external and internal IP address works, AND your TZO DNS name
matches your WAN IP (step 3) but your website still does not work (or you
get the wrong website served from your host server), double-check your
Apache .conf file... most likely there's a problem in your
NameVirtualHost settings. Check the Apache docs, and be sure to restart
your webserver after config changes.
-----------------------------------------

SUPPORT

 Any Qustions, Comments or new ways of using TZO in different Linux 
 Versions. please mailto:<support@tzo.com>. 

To speed delivery of your question to UNIX support, use subject line 
of "TZO Perl script" or "UNIX script". Thanks.
############################### 
