#!/usr/bin/perl
#
# Edit the path to perl above if the path is incorrect
#
######################################################
#                                                    #
#   TZO Install Script for tzoperl  ver. 2.0         #
#                                                    #
#   Author Jeff Cronstrom <jeff@tzo.com>             #
#                                                    #
#   Revised 05/01/2002                               #
#   Added OSX install support                        #
#                                                    #
######################################################

$debug = '0';

$tzorconf = "/etc/tzo/tzopl.conf";

$ROOTUSER = 'root';
$ROOTGROUP = 'root';

$TZOUSER = 'nobody';
$TZOGROUP = 'nobody';

$OSXGROUP = 'wheel';

$tzodir = '/etc/tzo';
$remotehst = "rh.tzo.com";

$tzo_pid = '/var/run/tzoupdate.pid';

# Use /Library/StartupItems/TZO -- not /System/Library/...
$osxstartdir = '/Library/StartupItems/TZO';

$osxstartfile = '/etc/hostconfig';

die "You Must Run This Installer as root\n" if $> ne '0';

$upgrade = 0;

if ( -e "/etc/tzo/tzopl.conf" ) {
	do "/etc/tzo/tzopl.conf";
	$upgrade = 1;	
} elsif ( -e "/etc/tzopl.conf" ) {
	do "/etc/tzopl.conf";
	$upgrade = 1;
}

do "tzopl.pm";

if ($upgrade) {
	
	sleep 1;
	print "\n\t - Previous Configuration Found\n";
	sleep 1;
	print "\n\t - Upgrading to... $ver\n\n\n";
	sleep 1;
	
	if (-e "$tzo_pid") {
		
		print "TZO Daemon Service Found Running\n";
		sleep 1;
		print ".\n";
		sleep 1;
		print ".\n\n";
		
		if (-e "/etc/rc.d/init.d/tzod") {
			
			system("/etc/rc.d/init.d/tzod stop");
			
		} elsif (-e "/etc/init.d/tzod") {
			
			system("/etc/init.d/tzod stop");
			
		}   
		
		system("rm -f $tzo_pid") if (-e "$tzo_pid") ;
		
		$stopped = "1";
		sleep 1;
		print ".\n";
		sleep 1;
		print ".\n\n";
	}
	
} else {
	
	print "\n\t - Installing... $ver \n";
	sleep 1;
	print ".\n";
	sleep 1;
	print ".\n\n";
	
	if (-e "$tzo_pid") {
	
		print "TZO Daemon Service Found Running\n";
		sleep 1;
		print ".\n";
		sleep 1;
		print ".\n\n";
	
		if (-e "/etc/rc.d/init.d/tzod") {
	
			system("/etc/rc.d/init.d/tzod stop");
	
		} elsif (-e "/etc/init.d/tzod") {
	
			system("/etc/init.d/tzod stop");
	
		}
	
		system("rm -f $tzo_pid") if (-e "$tzo_pid") ;
	
	}  
		
		system("rm -f $tzo_pid") if (-e "$tzo_pid") ;
		$stopped = "1";

}

print "Entering TZO Setup Wizard\n";
sleep 1;
print ".\n";
sleep 1;
print ".\n\n";
sleep 1;

##################

print "\n\n";
print "   ***************** TZO Wizard ************************ \n\n";
print "   You have entered the TZO configuration Wizard\n\n";
print "   You will need to have the information you were\n";
print "   sent from TZO in order to complete this wizard.\n";
print "   Make sure you have your TZO KEY, Domain Name and \n";
print "   email address you used to signup to TZO.\n\n";
print "   If you do not have a TZO KEY please send an email\n";
print "   to $cluster and you will be issued a\n";
print "   free 30 day trial key.\n\n";
print "   Any value in brackets [] is the default value.\n";
print "   If you enter a new value the default will be ignored.\n\n";

print "   ***************** TZO Wizard ************************ \n\n";

# this loop is intended to signup a new tzo name if the user has no tzo name
# or domain name. This will pull the information for the appropriate
# cluster after contacting the TZO oem server.

#if (!$ENV{'OSTYPE'}) {
	
	$myostype = 1;
	
#}

while($myostype) {
		
	print "   Please specify your Operating System.\n\n";
	print "   1 - for Solaris\n";
	print "   2 - for Linux\n";
	print "   3 - for FreeBSD\n";
	print "   4 - for MAC OSX\n";
	print "   OS Type [$OS]: ";
	
	$osconf = <STDIN>;
	chop($osconf);
		
	if ( $osconf eq "1" || $OS =~ 'Solaris'  ) {
		
		undef $OS;	
		$OS = 'Solaris';
		print "\n\n   Using OS Type: [$OS] \n\n";
		$myostype = 0;
		sleep 1;
		
	} elsif ( $osconf eq "2" || $OS =~ 'Linux' ) {
		
		undef $OS;
		$OS = 'Linux';
		print "\n\n   Using OS Type: [$OS] \n\n";
		$myostype = 0;
		sleep 1;
			
	} elsif ( $osconf eq "3" || $OS =~ 'FreeBSD' ) {
		
		undef $OS;
		$OS = 'FreeBSD';
		print "\n\n   Using OS Type: [$OS] \n\n";
		$myostype = 0;
		sleep 1;
		
	} elsif ( $osconf eq "4" || $OS =~ 'OSX' ) {
		
		undef $OS;
		$OS = 'OSX';
		print "\n\n   Using OS Type: [$OS] \n\n";
		$myostype = 0;
		sleep 1;
	
	} elsif ( $OS =~ 'Solaris' ) {
		
		undef $OS;	
		$OS = 'Solaris';
		print "\n\n   Using OS Type: [$OS] \n\n";
		$myostype = 0;
		sleep 1;

	} elsif ( $OS =~ 'Linux' ) {
		
		undef $OS;
		$OS = 'Linux';
		print "\n\n   Using OS Type: [$OS] \n\n";
		$myostype = 0;
		sleep 1;
		
	} elsif ( $OS =~ 'FreeBSD' ) {
		
		undef $OS;
		$OS = 'FreeBSD';
		print "\n\n   Using OS Type: [$OS] \n\n";
		$myostype = 0;
		sleep 1;
		
	} elsif ( $OS =~ 'OSX' ) {
		
		undef $OS;
		$OS = 'OSX';
		print "\n\n   Using OS Type: [$OS] \n\n";
		$myostype = 0;
		sleep 1;		
	
	} else {
		
		undef $OS;	
		$myostype = 1;
		undef;
		redo;
		
	}

}

$namepass = 1;

while($namepass) {

	print "   Please enter your domain name or TZO name.\n";
	print "   e.g. ( domain.com or name.tzo.com )\n\n";
	print "   TZO Name [$TZONAME]: ";
	$conf2 = <STDIN>;
	chop($conf2);
	
	if (length $conf2 > 67) {
		
		print "\n ERROR:  Domain name too long - please re-enter.\n\n";
		undef;
		redo;
		
	} elsif ( $conf2 eq "" && $TZONAME ) {
		
		print "\n\n   Using current name: [$TZONAME] \n\n";
		$conf2 = $TZONAME;
		$namepass = 0;
		sleep 1;
		
	} elsif ($conf2 !~ /^[a-zA-Z0-9][a-zA-Z0-9\-\.]*[a-zA-Z0-9]\.([a-zA-Z]*[a-zA-Z])$/) {
	
		print "\n\n   Please enter a valid Domain Name, Invalid Characters! \n\n\n";
		undef;
		redo;
	
	} else {
	
		print "\n\n   Using name: [$conf2] \n\n";
		$namepass = 0;
		sleep 1;

	}
       
}
	
	# Setup email address
	
	$emailpass = 1;

	if ($TZOEMAIL) {
		if ($TZOEMAIL =~ /FILLIN/) {
			$TZOEMAIL = "";
		}
	}

while($emailpass) {

	print "\n   Your Email Address [$TZOEMAIL]: ";
	$conf1 = <STDIN>;
	chop($conf1);
	
	if ($conf1 eq "" && $TZOEMAIL) {
		
		print "\n\n   Using current email address: [$TZOEMAIL]\n\n";
		$conf1 = $TZOEMAIL;
		$emailpass = 0;
		sleep 1;
		
	} elsif ($conf1 =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/ || $conf1 !~ /^\S+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$/) {
		
		print "\n\n   Please enter a valid email address!\n";
		undef;
		redo;
		
	} else {

		print "\n\n   Using email address: [$conf1]\n\n";
		$emailpass = 0;
		sleep 1;

	}

}
     
     # Setup tzo key
     
	$keypass = 1;

	if ($TZOKEY) {
		if ($TZOKEY =~ /FILLIN/) {
			$TZOKEY = "";
		}
	}

while($keypass) {

	print "\n   Your TZO Key [$TZOKEY]: ";
	$conf3 = <STDIN>;
	chop($conf3);
	
	if ($conf3 eq "" && $TZOKEY) {
		
		$conf3 = $TZOKEY;
		$keypass = 0;
		print "\n\n   Using current TZO Key: [$conf3]\n\n";
		sleep 1;
		
     } elsif (length $conf3 > 16 || length $conf3 < 16 ) {
     	print "\n\n   Please enter the TZO Key! Incorrect Syntax\n";
     	undef;
     	redo;
	} elsif ( $conf3 !~ $TZOKEY ) {
		
		print "\n   TZO Key Again: ";
		$conf32 = <STDIN>;
		chop($conf32);

		if (!checksame($conf3, $conf32)) {
			print "\n\n  Please enter the same TZO Key twice!\n";
			undef;
			redo;
		}
		
		$keypass = 0;
		
		print "\n   Using TZO Key: [$conf3]\n\n";
		sleep 1;

		} else {

			$keypass = 0;
			print "\n   Using TZO Key: [$conf3]\n\n";
			sleep 1;

		}

}

     # Setup interface
     
	$i_face = 1;

	if ($interface) {
		if ($interface =~ /FILLIN/) {
			$interface = "";
		}
	}

while ($i_face) {
     
	print "\n\n   Please specify an interface type - eg. ( eth0, en0, le0, ppp0 ) \n";
	print "\n   Linux Example: eth0 or eth1 or ppp0\n";
	print "\n   Solaris Example: de0 or xl0 - depends on the manufacturer\n";
	print "\n   BSD Example: de0 or xl0 - depends on the manufacturer\n";
	print "\n   OSX Example: en0 or en1\n\n";
	print "\n   Current Interface Type [$interface]: ";

	$conf0 = <STDIN>;
	chop($conf0);
	
	if ($conf0 eq "") {
		
		$conf0 = $interface;
		if (!$conf0 ) {

			print "   Please specify a valid Interface Type\n\n";
			undef;
			redo;
			
		}
		
		$interface = $conf0;
		
	}
	
	print "\n\n   Using interface: [$conf0] \n\n";
	$i_face = 0;
	sleep 1;
       
}
     
     # Setup connection type

	$c_type = 1;

	if ($CTYPE) {
		if ($CTYPE =~ /FILLIN/) {
			$CTYPE = "";
		}
	}

while ($c_type) {

	print "\n\n   Please enter your system's Connection Type.\n";
	print "   This is important for getting your systems IP Address.\n\n";
	print "   (Connection Types)\n\n";
	print "   1  for  Dial-up Modem\n";     
	print "   2  for  Cable Modem\n";     
	print "   3  for  LAN (Local Area Network)\n";     
	print "   4  for  ADSL, HDSL, xDSL\n";     
	print "   5  for  America Online Dial-up\n";     
	print "   6  for  Other Connection Type\n";
	print "   7  for  Static IP Address\n";
	print "   Please enter your connection type.\n\n";

	# FIXME: Add in help code, print cache table in mins.";
	print "   Your Connection Type [$CTYPE]: ";
	
	undef $conf4;
	$conf4 = <STDIN>;
	chop($conf4);
	
	if ($conf4 eq "") {
		
		$conf4 = $CTYPE;
		$c_type = 0;
		$conf16 = "";
		sleep 1;
		
	}
     
	print "\n   Using Connection type: [$conf4]\n\n";
	
	if ($conf4 eq "7") {
		
		undef $interface;
		$interface = $conf0;
		
		get_adaptor();
		
		$staticip = $IPADDRESS if ($IPADDRESS);
		
		sleep 1;
		
		print "\n   Please Enter Your Static IP Address.\n\n";
		print "   Static IP: [$staticip] ";
		
		$conf16 = <STDIN>;
		chop($conf16);
		
		if ($conf16 eq "" ) {
			
			$conf16 = $staticip;
			
		}     	
		
		if ($conf16 !~ /([0-9]{1,3}(\.[0-9]{1,3}){3})/ || !$conf16 ) {
			
			print "\n\n   Please enter a valid IP Address, Invalid Characters! \n\n\n";
			undef;
			redo;
			
		}
		
		print "\n\n   Using Static IP Address: [$conf16]\n";
		
	}
	
	if (length $conf4 > 1 || length $conf4 < 1 ) {
		
		print "\n\n   Please enter a valid connection type\n";
		undef;
		redo;
		
	}
	
	$c_type = 0;
	sleep 1;

}
     
     # Setup Logfile for all Signon/Signoffs
     
	print "\n   This file is where all signon/signoffs get logged.";
	print "\n   Usage Log Location [/var/log/tzousage.log]: \n";
	
	$conf8 = "/var/log/tzousage.log";
	
	sleep 1;  	

	print "\n   This file is where the current IP Address gets logged.";
	print "\n   IP Address Log Location [/var/log/tzoip.log]: ";

	$conf6 = "/var/log/tzoip.log";
	
	sleep 1;
	
	# Specify path to current perl version
	# FIXME: need to add a Windows test here.
	
	if (-e "/usr/bin/perl") {
		
		$perl_path = '/usr/bin/perl';
		
	} elsif (-e "/usr/local/bin/perl") {
		
		$perl_path = '/usr/local/bin/perl';
		
	} else {
		
		$perl_path = 'path_to_perl';
		
	}
		
		
	
	print "\n\n   Enter the Path to Perl [$perl_path]: ";
	
	$confp = <STDIN>;
	chop($confp);
	
	if ($confp eq "") {
		
		$confp = "/usr/bin/perl";
		
	}
	
	if (! -e $confp || $confp eq "path_to_perl") {
		
		print "Incorrect Path... Please Re-Enter\n\n";
		sleep 1;
		redo;
		
	}
	
	print "\n   Path to Perl: [$confp] \n\n";
	sleep 1;
     
	# Specify if you are connecting through a gateway
     
	print "\n   Do you connect through a gateway? Yes = 1, No = 0 \n";
	print "\n   Gateway Value [$gateway]:";
	$conf5 = <STDIN>;
	chop($conf5);
	
	if ($conf5 eq "") {
		
		$conf5 = "$gateway";
		
	}
	
	if ( $conf5 ) {
		
		print "\n\n   You are going through a Gateway: [$conf5] \n\n";
		$netcon = "Gateway Network Adaptor";
		sleep 1;
		
	} else {
		
		print "\n\n   You are not going through a Gateway: [$conf5] \n\n";
		$netcon = "Local Network Adaptor";
		sleep 1;

	}
  	
	# Setup IP Checking interval

	if ($checkip) {
	
		if ($checkip =~ /FILLIN/) {
			
			$checkip = "";
		
		}

	}

	print "\n   TZO DDNS is Being Configured to run as a Daemon!\n\n";

	$ip_interval = 1;
	$tzodaemon = 1;
	sleep 1;
		
while ($ip_interval) {
	
	if (!$checkip) {
		
		$checkip = "10-min";
		
	} 
	
	if ($tzodaemon) {
		
		print "\n   How often do you want TZO to check for an IP \n";
		print "   Address change on your $netcon? \n\n";
		print "\n   Valid Values for IP Address Check Interval \n\n";
		print "    1-min \n";
		print "    2-min \n";
		print "    5-min \n";
		print "    10-min \n";
		print "    30-min \n";
		print "    1-hour \n";
		print "    2-hours \n";
		print "    8-hours \n";
		print "    24-hours \n";
		print "    2-days \n";
		print "    Never \n";
		print "   IP Address Check Interval every [$checkip]: ";
		
		#print "FIXME: Need to add help explanation here";
		$conf7 = <STDIN>;
		chop($conf7);
		
		if ($conf7 eq "" && $checkip) {
			
			$conf7 = "$checkip";
		
		} elsif ($conf7 eq "") {
			
			$conf7 = "10-min";
		
		}

		if ($conf7 !~ /^(1-min|2-min|5-min|10-min|30-min|1-hour|2-hours|8-hours|24-hours|2-days|Never)$/  || $checkip && $conf7 eq "") {
			
			print "\n\n   Please enter a valid Interval \n\n";
			sleep 1;
			undef;
			redo;
			$ip_interval = 1;
		
		}
		
		undef $tzodaemon;
		$tzodaemon = "Y";
		$ip_interval = 0;
		
		print "\n\n   Address checking Interval every: [$conf7] \n";
		print "   on your $netcon \n\n";
		sleep 1;
     	     	
     }

}     

     
	# Setup port to connect to the TZO Servers on
	
	$conport = 1;
	while ($conport) {
		
	print "   The TZO client makes an outgoing network connection\n";
	print "   to tzo.com, using either ports 80 or 21333.\n\n";

	print "   TZO reccomends using the default setting, port 21333.\n\n";

	print "     Port 80 is not always a good choice because your\n";
        print "   Internet provider may transparently force all port 80\n";
	print "   traffic through a caching proxy (such as Squid, etc.).\n";
        print "   This could cause the HTTP IP detection to obtain a\n";
        print "   false IP address and your DNS reccord would be incorrect.\n";

	print "   Connect to TZO on port [21333]:";
	
	$conf9 = <STDIN>;
	chop($conf9);
     
	# need to add validator for port 21333
     
	if ($conf9 eq "") {
		
		$conf9 = "21333";
		$conport = 0;
	
	} elsif ($conf9 eq "80" || $conf9 eq "21333" ) {
		
		$conf9 = $conf9;
		$conport = 0;
	
	} else {
		
		print "\n\n   Please enter a valid port number!\n\n\n";
		sleep 1;
		redo;
		$conport = 1;
	
	}
	 
}
	
	print "\n\n   Connecting to TZO on Port [$conf9]\n\n";
  	  
	sleep 1;

	$offline = 1;

while($offline) {
	
	undef $conf11;
	print "\n\n\n   Please enter an IP Address you would\n";
	print "   like to point to if you signoff. TZO has\n";
	print "   a default IP specified, but you may enter your\n";
	print "   own. Default \"209.25.206.84\", \"0.0.0.0\" for none\n\n";
	print "   Offline IP [$offlinepage]: ";

	$conf11 = <STDIN>;
	chop($conf11);

	if (length $conf11 > 15 ) {

		print "\n\n   Please enter a valid IP Address! \n\n\n";
		undef;
		redo;

	} elsif ( $conf11 eq "" && $offlinepage ) {
		
		$conf11 = $offlinepage;
		print "\n\n   Using current IP Address: [$conf11] \n\n\n\n";
		$offline = 0;
		sleep 1;

	} elsif ($conf11 !~ /([0-9]{1,3}(\.[0-9]{1,3}){3})/) {

		print "\n\n   Please enter a valid IP Address, Invalid Characters! \n\n\n";
		undef;
		redo;

	} else {

		print "\n\n   Using IP Address: [$conf11] \n\n\n\n";
		$offline = 0;
		sleep 1;

	}
       
}

	if ($tzodaemon) {
		
		$mailfail = 1;

	}
	
	if ($OS eq "OSX") {
	
		$mailfail = 0;
	
	}

while($mailfail) {

	$mailipa = $TZOEMAIL if (!$mailipa);

	print "\n   Would you like the daemon to mail you if your\n";
	print "   IP Address gets updated? This will mail you when the\n";
	print "   daemon is started or if the IP Address changes.\n\n";
	print "   Please specify \"yes\" or \"no\" Default [$ipmail]: ";

	$conf14 = <STDIN>;
	chop($conf14);

	if ($conf14 eq "") {

		$conf14 = $ipmail;

		if ($conf14 eq "") {
		
			undef $conf14;
			redo;
		
		}
	
	}
	
	if ($conf14 =~ /^[yY]/) {
		
		$mailme = 1;
		while ($mailme) {
			
			undef $conf14;
			$conf14 = "y";
			
			print "\n   TZO DDNS Mailer is configured to mail you upon change!\n\n\n\n";
			print "   Please specify an email address to send to [$mailipa]: ";
			
			$conf15 = <STDIN>;
			chop($conf15);
			
			if ($conf15 eq "") {
			
				undef $conf15;
				$conf15 = $mailipa;
			
			}
			
			if ($conf15 eq "" || $conf15 =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/ || $conf15 !~ /^\S+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$/) {
				
				print "\n\n   Please enter a valid email address!\n";
				undef;
				redo;
				$mailme = 1;
			
		
			} else {
				$mailme = 0;
		
			}
		
		}
		
	print "\n\n   Using Email Address: [$conf15] \n\n\n";
		
	$mailfail = 0;
	sleep 1;
	
	} elsif ($conf14 =~ /^[nN]/) {
		print "\n\n   Not using Email Notify!\n\n\n";
		$mailfail = 0;
		sleep 1;
	} else {
		print "\n\n   Please Enter Yes or No!\n\n\n";
		redo;
		$mailfail = 1;
	}
       
}

######### DO INSTALL ##########

# Write configuration to file


# Solaris
# ln -s /etc/init.d/tzod /etc/rc0.d/K20tzod
# ln -s /etc/init.d/tzod /etc/rc3.d/S99tzod

print "\n\n************* DOING INSTALL *************\n\n\n";
sleep 1;

if (-e "/etc/tzo") {
	
	print "Directory \"$tzodir\" already installed, Continuing Installation.\n\n";
	
} else {
	
	system("mkdir -m 644 /etc/tzo/");
	
	if (-e "/etc/tzo/") {
		
		print "Created folder $tzodir for configuration file and library file.\n\n";
		
	} else {
		
		print "\n\n*** FAILED *** To Create folder $tzodir for configuration file and library file.\n\n";
		sleep 1;
		
	}
	
}

if (-e "/usr/bin/tzopl.pm") {
	
	unlink("/usr/bin/tzopl.pm");
	
} elsif (-e "/etc/tzo/tzopl.pm") {
	
	unlink("/etc/tzo/tzopl.pm");
	
}

if (-e "/usr/bin/tzoperl-1.6.pl") {
	
	unlink("/usr/bin/tzoperl-1.6.pl");
	
} elsif (-e "/usr/bin/tzo") {

	unlink("/usr/bin/tzo");
	
}

sleep 1;

  #############################
 ## Solaris Install Section ##
#############################

if ($OS eq 'Solaris' ) {

	system("install -f /etc/tzo -m 644 -u $TZOUSER -g $TZOGROUP README.perl");
	
	if (-e "/etc/tzo/README.perl") {
		
		print "Created \/etc\/tzo\/README.perl for README file.\n\n";
		
	} else {
		
		print "\n\n*** FAILED *** to Create \/etc\/tzo\/README.perl for README file.\n\n";
		sleep 1;
		
	}

	system("install -f $tzodir -m 644 -u $ROOTUSER -g $ROOTGROUP tzopl.pm");
	
	if (-e "$tzodir/tzopl.pm") {
		
		print "Succesfully Installed tzopl.pm into \"$tzodir\"\n\n";
		
	} else { 
		
		print "\n\n*** FAILED *** to Install tzopl.pm into \"$tzodir\"\n\n";
		sleep 1;
		
	}
	
	system("install -f /usr/bin -m 755 -u $ROOTUSER -g $ROOTGROUP tzo");
	
	if (-e "/usr/bin/tzo") {
		
		print "Succesfully Installed tzo into \"/usr/bin/\"\n\n";
		
	} else {
		
		print "\n\n*** FAILED *** To Install tzo into \"/usr/bin/\"\n\n";
		sleep 1;
		
	}
	
  #############################
 ## FreeBSD Install Section ##
#############################
	
} elsif ($OS eq 'FreeBSD') {
	
	undef $ROOTGROUP;
	$ROOTGROUP = 'wheel';
	
	system("install -g $TZOGROUP -m 644 -o $TZOUSER README.perl /etc/tzo/README.perl");
	
	if (-e "/etc/tzo/README.perl") {
		
		print "Created \/etc\/tzo\/README.perl for README file.\n\n";
		
	} else {
		
		print "\n\n*** FAILED *** to Create \/etc\/tzo\/README.perl for README file.\n\n";
		sleep 1;
		
	}
	
	system("install -g $ROOTGROUP -m 644 -o $ROOTUSER tzopl.pm $tzodir/tzopl.pm");

	if (-e "$tzodir/tzopl.pm") {
		
		print "Succesfully Installed tzopl.pm into \"$tzodir\"\n\n";
		
	} else { 
		
		print "\n\n*** FAILED *** to Install tzopl.pm into \"$tzodir\"\n\n";
		sleep 1;
		
	}
	
	system("install -g $ROOTGROUP -m 755 -o $ROOTUSER tzo /usr/bin/tzo");
	
	if (-e "/usr/bin/tzo") {
		
		print "Succesfully Installed tzo into \"/usr/bin/\"\n\n";
		
	} else {
		
		print "\n\n*** FAILED *** To Install tzo into \"/usr/bin/\"\n\n";
		sleep 1;
		
	}
	
  #############################
 ##   OSX   Install Section ##
#############################

} elsif ($OS eq 'OSX') {
	
	undef $ROOTGROUP;
	$ROOTGROUP = $OSXGROUP;
	
	system("install -c -g $TZOGROUP -m 644 -o $TZOUSER README.perl /etc/tzo/README.perl");
	
	if (-e "/etc/tzo/README.perl") {
		
		print "Created \/etc\/tzo\/README.perl for README file.\n\n";
		
	} else {
		
		print "\n\n*** FAILED *** to Create \/etc\/tzo\/README.perl for README file.\n\n";
		sleep 1;
		
	}
	
	system("install -c -g $ROOTGROUP -m 644 -o $ROOTUSER tzopl.pm $tzodir/tzopl.pm");

	if (-e "$tzodir/tzopl.pm") {
		
		print "Succesfully Installed tzopl.pm into \"$tzodir\"\n\n";
		
	} else { 
		
		print "\n\n*** FAILED *** to Install tzopl.pm into \"$tzodir\"\n\n";
		sleep 1;
		
	}
	
	system("install -c -g $ROOTGROUP -m 755 -o $ROOTUSER tzo /usr/sbin/tzo");
	
	if (-e "/usr/sbin/tzo") {
		
		print "Succesfully Installed tzo into \"/usr/sbin/\"\n\n";
		
	} else {
		
		print "\n\n*** FAILED *** To Install tzo into \"/usr/sbin/\"\n\n";
		sleep 1;
		
	}



	if (-e "$osxstartdir") {
		
		print "Directory \"$osxstartdir\" already installed, Continuing Installation.\n\n";
	
	} else {
	 	# Don't assume parent directory exists - use '-p'	
		system("mkdir -m 755 -p $osxstartdir");
		
		if (-e "$osxstartdir") {
			
			print "Created folder \"$osxstartdir\" for startup files.\n\n";
			
		}
		
		if (-e "$osxstartdir/TZO") {
			
			print "TZO already installed in \"$osxstartdir\", Continuing Installation\n\n";
		
		} else {
			
			system("install -c -g $ROOTGROUP -m 755 -o $ROOTUSER osx/TZO $osxstartdir/TZO");
		
			if (-e "$osxstartdir/TZO") {
		
				print "Succesfully Installed TZO into \"$osxstartdir\"\n\n";
		
			} else { 
		
			print "\n\n*** FAILED *** to Install TZO into \"$osxstartdir\"\n\n";
			sleep 1;
		
			}
		
		}
		
		if (-e "$osxstartdir/StartupParameters.plist") {
			
			print "StartupParameters.plist already installed in \"$osxstartdir\", Continuing Installation\n\n";
		
		} else {
					
			system("instaLl -c -g $ROOTGROUP -m 755 -o $ROOTUSER osx/StartupParameters.plist $osxstartdir/StartupParameters.plist");
		
			if (-e "$osxstartdir/StartupParameters.plist") {
		
				print "Succesfully Installed StartupParameters.plist into \"$osxstartdir\"\n\n";
		
			} else { 
		
				print "\n\n*** FAILED *** to Install StartupParameters.plist into \"$osxstartdir\"\n\n";
				sleep 1;
			
			}
		
		}
		
	}
	


# here we need to add "TZO=-YES-" to "/etc/hostconfig"

$cfgbak = "$osxstartfile.bak";

$addsrvc = 'TZO=-YES-';
$delsrvc = 'TZO=-NO-';

# uninstall service if set to "1"
# will install service if left blank
$myuninstall = "";

if (-e "$osxstartfile") {
		
	open(HSTCFG, "< $osxstartfile");
	
		@lines = <HSTCFG>;
		
			foreach $line (@lines){

				$count++;
					
				# backup file before the mangle begins!
				# hostconfig.bak
				
				open (BAK, ">" .$cfgbak);

        			if ($flock) {
                
						flock(BAK, 2)
        
        			}
        				
        			print BAK @lines;
        				
				close (BAK);					

				# We will remove the TZO service startup from the
				# system service startup file :)
				# if we are removing the service (uninstall)
				# we will use this method
				
				if ($myuninstall) {
					 		
					open (REM, ">" .$osxstartfile);
	
	        			if ($flock) {
	                
							flock(REM, 2)
	        
	        			}
	        					
	        			next if $line =~ /TZO/;
	
	        			$all .= $line;
	
	        			print REM $all;
							
					close (REM);
					
				}
					
					# if we are modifing the starup to "YES"
					# we will use this method
				
				if (!$myuninstall) {
								
					open (NEW, ">" .$osxstartfile);
	
	        			if ($flock) {
	                
							flock(NEW, 2)
	        
	        			}
	        			
	        			next if $line =~ /TZO/;
	        			
	        			#$new .= $line;
	        			
	        			if ($count == 26) {
	
	        				$line .= "$addsrvc\n";
	        			
	        			}
	        			
	        			$new .= $line;
	        			
	        			print NEW $new;
	        				
					close (NEW);				
				}
														
			}

		if ($debug) { print "Count: $count\n\n"; }
		if ($debug) { print "All: \n$all\n\n"; }
		
	close(HSTCFG);
		
} else {
			
		print "\n\n*** FAILED *** To Create folder \"$osxstartdir\" for startup files.\n\n";
		print "\n\n*** NOTE *** Auto start will not work correctly.\n\n";
		sleep 1;
			
}
	

		

	
  #############################
 ##  Linux  Install Section ##
#############################	
	
} elsif ($OS eq 'Linux') {

	system("install -m 644 -o $TZOUSER -g $TZOGROUP README.perl /etc/tzo/README.perl");
	
	if (-e "/etc/tzo/README.perl") {
		
		print "Created \/etc\/tzo\/README.perl for README file.\n\n";
		
	} else {
		
		print "*** FAILED *** to Create \/etc\/tzo\/README.perl for README file.\n\n";
		
	}
	
	system("install -m 644 -o $ROOTUSER -g $ROOTGROUP tzopl.pm $tzodir/tzopl.pm");

	if (-e "$tzodir/tzopl.pm") {
		
		print "Succesfully Installed tzopl.pm into \"$tzodir\"\n\n";
		
	} else { 
		
		print "\n\n*** FAILED *** to Install tzopl.pm into \"$tzodir\"\n\n";
		sleep 1;
		
	}
	
	system("install -m 755 -o $ROOTUSER -g $ROOTGROUP tzo /usr/bin/tzo");
	
	if (-e "/usr/bin/tzo") {
		
		print "Succesfully Installed tzo into \"/usr/bin/\"\n\n";
		
	} else {
		
		print "\n\n*** FAILED *** To Install tzo into \"/usr/bin/\"\n\n";
		sleep 1;
		
	}
	
} # end OS type eq

$tzod = 1;

if ($tzod) {
	
	if (-e "/etc/init.d/") {
	
		$initdir = "/etc/init.d";
	
	} elsif (-e "/etc/rc.d/init.d/") {
	
		$initdir = "/etc/rc.d/init.d";
	
	}
	
	if ($OS eq "solaris") {
		
		system("install -f $initdir -m 755 -u $ROOTUSER -g $ROOTGROUP tzod");
		
		if (-e "$initdir/tzod") {
			
			print "Succesfully Installed tzod into \"$initdir\"\n\n";
			
		} else {
			
			print "\n\n*** FAILED *** To Install tzod into \"$initdir\"\n\n";
			sleep 1;
			
		}
		
	} elsif ($OS eq 'FreeBSD') {
		
		undef $initdir;
		$initdir = "/usr/local/etc/rc.d";
		
		system("install -g $ROOTGROUP -m 755 -o $ROOTUSER tzod $initdir/tzod.sh");
		
		if (-e "$initdir/tzod.sh") {
			
			print "Succesfully Installed tzod.sh into \"$initdir\"\n\n";
			
		} else {
			
			print "\n\n*** FAILED *** To Install tzod.sh into \"$initdir\"\n\n";
			sleep 1;
			
		}
		
	} elsif ($OS eq 'Linux') {
		
		system("install -m 755 -o $ROOTUSER -g $ROOTGROUP tzod $initdir/tzod");
		
		if (-e "$initdir/tzod") {
			
			print "Succesfully Installed tzod into \"$initdir\"\n\n";
			
		} else {
			
			print "\n\n*** FAILED *** To Install tzod into \"$initdir\"\n\n";
			sleep 1;
			
		}	
		
	}
	  
  # look in /var/run/runlevel.dir, or initrunlevel for # for runlevel to install into
  # create simlinks for runtime start-up files

	if ($OS eq "solaris") {
		
		if ( ! -e "/etc/rc3.d/S99tzod") {
			
			system("ln -s /etc/init.d/tzod /etc/rc3.d/S99tzod");
			
		}
		if ( ! -e "/etc/rc0.d/K20tzod") {
			
			system("ln -s /etc/init.d/tzod /etc/rc0.d/K20tzod");
			
		}
		
		print "TZO Successfully Installed as a Service\n\n";
		
	} elsif ($OS eq 'FreeBSD') {
		
		if ( -e "/usr/local/etc/rc.d/tzod.sh") {
			
			print "TZO Successfully Installed as a Service\n\n";
				
		}
	
	} elsif (! -e "/etc/rc3.d/S92tzo" || ! -e "/etc/rc.d/rc3.d/S92tzo" ) {
			
		system("/sbin/chkconfig --add tzod");
		
		sleep 1;
		print "TZO Successfully Installed as a Service\n\n";
		
	} else {
		
		sleep 1;
		print "TZO Startup Service Already Installed!... Continuing Install...\n\n";
  	 
	}
  
}

print "Writing Configuration to file.\n\n";

writeconf();

sleep 1;

#system("chown nobody.nobody /etc/tzo/tzopl.conf");

if (!$upgrade) {
	
	if ($OS eq "OSX") {
		
		print "\nYou may now run $ver from /usr/sbin\n";
		
	} else {
		
		print "\nYou may now run $ver from /usr/bin\n";
		
	}
	
	print "\nTo start the TZO DDNS Daemon, run $ver -d from /usr/bin\n";
	print "\nTZO DDNS Daemon will also start whenever the system\n\n";
	print "is restarted.\n\n";
	sleep 1;
	print "***********INSTALL COMPLETE*************\n\n\n";
	
} else {
	print "Upgrade Completed!\n\n\n";
	sleep 1;
	print "***********INSTALL COMPLETE*************\n\n\n";
}

sub writeconf {

open (WC, ">" .$tzorconf);
        if ($flock) {
                flock(WC, 2)
        }
        
print WC << "__EOS__"
#!$confp
#
# File: $tzodir/tzopl.conf
#
#
# If you do not have an account with TZO please send an email to $cluster.
#
#
# Please look at this entire file so you do not miss anything.
# Make sure to specify if you are going through a gateway or not - see below.
#
# Use the examples below for reference.
# Below this example you need to fill in the fields labeled "FILLIN".
#
#               ** EXAMPLES **
#
#       specify the interface - eg. eth0, eth1, ppp0, dhcp
#       \$interface \= "eth0";
#
#       insert your email address
#       \$TZOEMAIL \= 'user\@domain.com';
#
#       insert your domain name
#       \$TZONAME \= "domain.com"; ( or - "name.tzo.com";)
#
#       insert your TZO key
#       \$TZOKEY \= "XXXXXXXXXXXXXXXX";
#
#       select your connection type
#       
#       \$CTYPE = "3";
#
#               CTYPE (Connection Types)
#               1   Dial-up Modem
#               2   Cable Modem
#               3   LAN (Local Area Network)
#               4   ADSL, HDSL, xDSL
#               5   America Online Dial-up
#               6   Other Connection Type
#               7   Static IP Address
#
# Individual Account Settings
#
####***name1***####

\$interface \= "$conf0";

\$TZOEMAIL \= '$conf1';

\$TZONAME \= "$conf2";

\$TZOKEY \= "$conf3";

\$CTYPE \= "$conf4";

\$staticip \= "$conf16";

\$offlinepage \= "$conf11";

####***name1***####

# Are you going through a Gateway? (e.g. Firewall, NAT, 
# Linksys Cable/DSL Router) Selecting "Yes" will pass 
# a null IP Address for the Network Adaptor, thus posting
# the Gateway address. Selecting "No" will pass the 
# Network adaptors address regardless of a Gateway.
# 
# Yes \= 1 No \= 0
# Yes uses the gateway address
#
# No uses the network adaptor address
#
\$gateway \= "$conf5";
#
# Current IP Address log file
# Put this where ever you want.
#
\$iplog \= "$conf6";
#
# TZO Dameon start ref.
# If you want to run tzo as a daemon please specify here
#
#  # Yes \= 1 No \= 0
#
\$tzod \= "$conf10";
#
# * This is only for use if you are using the tzoupdate.pl daemon *
# Specify how often to check for an IP Address change
#
#       "1-min"
#       "2-min"
#       "5-min"
#       "10-min"
#       "30-min"
#       "1-hour"
#       "2-hours"
#       "8-hours"
#       "24-hours"
#       "2-days"
#       "Never"
#
\$checkip \= "$conf7";
#
# Log File of all Signons
# Put this where ever you want

\$usage \= "$conf8";

# Log PID form UpDate Daemon
\$tzopid \= "/var/run/tzo.pid";

# valid ports to use - '80' & '21333'. If you are going through a 
# squid proxy you probably want to use port '21333'.

\$hstport \= '$conf9';

# you should not need to change any of these settings...

\@g_keep \= ("echo.tzo.com","80");

\$hstpage \= '\$UPDATE';

\$ver = "$ver";
\$cluster = '$cluster';
\$OS = '$OS';

\$ipmail = '$conf14'; # 'y' or blank
\$mailipa = '$conf15';

\$dm  =   "Dial-up Modem";            
\$cm   =  "Cable Modem";              
\$ln  =   "LAN (Local Area Network)"; 
\$sl  =   "ADSL, HDSL, xDSL";         
\$ao   =  "America Online Dial-up";   
\$ot   =  "Other Connection Type";    
\$st   =  "Static IP Address";
#
#
# end of config file
#
#
#

__EOS__

}

close (WC);
