#!/usr/bin/perl
#
# ^--- Set your path to perl
#
# File:tzopl.pm
#
#
# Version Info

$ver = "tzo 2.14";
$cluster = 'tzolkin.signup@tzo.com';
$tzorconf = "/etc/tzo/tzopl.conf";

sub cluster {
	# Determine TZO servers based upon key type.
	if ($TZOKEY =~ /^[K]/) {
		$remotehst = "rh.tzo.com";
		$cluster = 'tzolkin.signup@tzo.com';
	} elsif ($TZOKEY =~ /^[S]/) {
                $remotehst = "rh.tzo.com";
                $cluster = 'tzolkin.signup@tzo.com';
	} else {
		# U keys, L keys, etc any OEM keys go here...
		$remotehst = "cgi.linksys.tzo.com";
		$cluster = 'linksys.signup@tzo.com';
	}
}

sub get_adaptor {
    #FIXME/TODO: Need a WinNT test here.
    if ($OS eq "solaris" || $OS eq "FreeBSD" || $OS eq "OSX") {
    	$IPADDRESS = `/sbin/ifconfig $interface` if ($interface);
        $IPADDRESS =~ s/^.*inet ([0-9]{1,3}(\.[0-9]{1,3}){3}).*$/$1/s;
    } elsif ($^O eq "MSWin32") { 
	# ipconfig will output LAN info, almost like ifconfig does in UNIX
	# LAN IP retrieval feature for Win32 is deferred until I have
	# a way to handle multiple network cards and Do The Right Thing.
	# TODO/FIXME
	#$IPADDRESS =~ `ipconfig `;
	print "BROKEN: Using LAN IP detection on Win32. Not supported.\n";
    } elsif ($^O eq "MacOS") {
	# Not sure how to do this
	print "BROKEN: LAN IP detection on MacOS classic NOT SUPPORTED. Fixme";
    } else {
        $IPADDRESS = `/sbin/ifconfig $interface` if ($interface);
        $IPADDRESS =~ s/^.*inet addr:([0-9]{1,3}(\.[0-9]{1,3}){3}).*$/$1/s;
    }
}

sub get_gate {
        if ($gateway) {
		getgateip();
        } else {
        	get_adaptor();
        }
}

sub go {
	    {
            $getsocket = IO::Socket::INET->new
                (
                PeerAddr        => $remotehst,
                PeerPort        => $hstport,
                Proto      	=> "tcp",
                Type            => SOCK_STREAM,
                Timeout  	=> 260
                ) or sleep 2, redo; 
	    }
                                                
        { $getsocket->autoflush(1) or sleep 2, redo; }
        #$url = "GET $UPDATE \n\n";
	$url = "GET $UPDATE \n User-Agent: TZO Perl $ver\n\n";
        $sstring = "$url";
	# FIXME/TODO -- within redo blocks, add a sentinel var
	# to NOT redo after too many tries, avoiding inf. loop
        { $getsocket->send($sstring) or sleep 62, redo; }

        while (<$getsocket>) {
        #FIXME: Is $list necessary? Seems redundant.
                $listtzo .= ($_);
                $list = $listtzo;
        }
        
    close($getsocket);
    undef $signwhat;
    
    if ($list =~ s/^.*Error=(([A-Za-z]{1,20}.([A-Za-z]{1,20}))).*$/$1/s) {
        $signwhat = "TZO Servers say you have an $list specified\n";
    } elsif ($list =~ /0.0.0.0.*/) {
        $signwhat = "Signing Off";
    } else {
        $signwhat = "Domain IP Updated";
    }
    # FIXME/TODO: tighten this so returned errors (like "invalid name")
    #  do not get assigned to all these variables. Just exit early.
    # Better error checking at the start of the script could prevent this.
    $tzo_name = $listtzo;
    
    $tzo_name =~ s/^.*TZOName=([A-Za-z-.0-9]{1,64}([A-Za-z-0-9]{1,64}([A-Za-z-0-9]{1,64}([A-Za-z-.0-9]{1,3})))).*$/$1/s; 
    $tzo_ip = $listtzo;
    $tzo_ip =~ s/^.*IPAddress=([0-9]{1,3}(\.[0-9]{1,3}){3}).*$/$1/s;        
    $tzo_expire = $listtzo;
    $tzo_expire =~ s/^.*Expiration=([0-9\/]{1,2}([0-9\/]{1,2}){4}).*$/$1/s;
        
    $TZOIP = "$tzo_ip";
    $TZO_NAME = "$tzo_name";
    $TZO_EXPIRE = "$tzo_expire";
} #end sub go();

sub signontzo {
    cluster();

    # hack. Band-aid to cover when -I [ipaddress] was not being used.
    # This will go away in the TZO Perl rewrite.
    if ($opt_I) {
        $IPADDRESS = $IPADDRESS;
    } else {
        get_gate();
    }
    
    $UPDATE = "/webclient/tzoperl.html?TZOName=$TZONAME&Email=$TZOEMAIL&TZOKey=$TZOKEY&CType=$CTYPE&IPAddress=$IPADDRESS&B1=Sign+On+to+TZO+DDNS+Servers";
    go(); 
    log_ip();
    close(SOCK);
    print "\n";
    # debuug note: For some IP-based (not NameVirtualHost) setups, you 
    # might want to add a line of code here to restart Apache, etc.
    # Most people don't need that tho.
}

sub signofftzo {
        $IPADDRESS = $offlinepage;
        cluster();
        $UPDATE = "/webclient/tzoperl.html?TZOName=$TZONAME&Email=$TZOEMAIL&TZOKey=$TZOKEY&CType=$CTYPE&IPAddress=$IPADDRESS&B1=Sign+On+to+TZO+DDNS+Servers";
        go();
        log_ip();
        close(SOCK);
        print "\n";     
}

sub log_ip {
    # write the current ip address to a single record log file
    open (IP, ">" .$iplog);

        if ($flock) {
                flock(IP, 2);
        }
        print IP $TZOIP;
        
    close (IP);

    # write the current domain name, ip address and date/time to an appended log file
 
    open (USAGE, ">>" .$usage);

        if ($flock) {
                flock(USAGE, 2);
        }
        print USAGE "$signwhat $TZONAME\, ";
        print USAGE "IP: $TZOIP\, ";
        print USAGE "Date: ", time_fmt(time),", ";
        print USAGE "Process # $$ \n";
        
    close (USAGE);

} # end sub log_ip()

sub logpid {
    open (TZO, ">" .$tzopid);
        if ($flock) {
                flock(TZO, 2);
        }
        print TZO "$$\n";
    close (TZO);
}

sub getgateip {
    $remote = "$g_keep[0]";
    $port = "$g_keep[1]";
    $UPDATE = "/ip.shtml";

        {$getip = IO::Socket::INET->new
                (
                PeerAddr        => $remote,
                PeerPort        => $port,
                Proto      => "tcp",
                Type            => SOCK_STREAM,
                Timeout  => 30
                ) or sleep 2, redo;}

        {$getip->autoflush(1) or sleep 2, redo;}

        #$url = "GET $UPDATE \n\n";
	$url = "GET $UPDATE \n User-Agent: TZO Perl $ver\n\n";
        $urlstring = "$url";
        {$getip->send($urlstring) or sleep 2, redo;} # "Could not send: $sstring \n";
                                        
        while (<$getip>) {
                #undef $listip;
                $listip = ($_);
                $line = $listip;
        }
   
    close($getip);
        
    undef $remote;
    undef $port;
    undef $UPDATE;
        
    $remote_ip = $line;
    $remote_ip =~ s/^.*IPAddress:([0-9]{1,3}(\.[0-9]{1,3}){3}).*$/$1/s;
    $IPADDRESS = "$remote_ip";
    $TZOIP = "$IPADDRESS";
    
}

sub time_fmt {
        
        my($sec, $min, $hour, $mday, $mon, $year) = localtime($_[0]);
        return(sprintf("%.2d/%.2d/%.4d %.2d:%.2d:%.2d", $mon + 1, $mday, $year + 1900, $hour, $min, $sec));

}

sub getlogip {

        {open (IPLOG,$iplog) or sleep 2, redo};
        while (<IPLOG>) {
                $logip = ($_);
        }
        close (IPLOG);
}

sub tzo_id {

        {open (TZOid,$tzopid) or sleep 2, redo};
                while (<TZOid>) {
                $tzopid = ($_);
        }
        close (TZOid);
}

sub checkit {

    get_gate();
    undef $logip;
    getlogip();

    unless ( -e $iplog && $logip =~ /$IPADDRESS/ && -e $tzopid ) {
        updatewhat();
        if ($ipmail eq "y") {
                $usermail = $mailipa;
            mailip();
        }
    }
        
    if ( ! $gateway ) {
        get_adaptor();
    }
}

sub updatewhat {
        signontzo();
}

sub ttl {
        
        $seconds = $checkip;    

        @match = ('1-min', '2-min', '5-min', '10-min', '30-min', '1-hour', '2-hours', '8-hours', 
'24-hours', '2-days', 'Never');
        
        if ($seconds =~ $match[0]) { $r1 = "60"; }
        if ($seconds =~ $match[1]) { $r1 = "120"; }
        if ($seconds =~ $match[2]) { $r1 = "300"; } 
        if ($seconds =~ $match[3]) { $r1 = "600"; }
        if ($seconds =~ $match[4]) { $r1 = "1800"; }
        if ($seconds =~ $match[5]) { $r1 = "3600"; }
        if ($seconds =~ $match[6]) { $r1 = "7200"; }
        if ($seconds =~ $match[7]) { $r1 = "14400"; }
        if ($seconds =~ $match[8]) { $r1 = "28800"; }
        if ($seconds =~ $match[9]) { $r1 = "86400"; }
        if ($seconds =~ $match[10]) { exit 0; }

        $echottl = $r1;
        
}

sub killd {
	if ( ! -e "$tzopid" ) {
		print "TZO Daemon is not running!\n\n";
		exit 0;
	}

	open (TZOid,$tzopid) or warn "Cannot Open TZO PID";
		while (<TZOid>) {
			$tzo_pid = ($_);
		}

	close (TZOid);
	system("kill $tzo_pid");
	sleep 1;
	unlink($tzopid) or die "Can't delete $tzopid: $!\n";
}

#
#sub mailkeyPerl {
    #FIXME: Better error handling if Net::SMTP is not installed (OS X)
    #FIXME/TODO : Hardcoded test function. Cleanup, make generic mailer.
#    use Net::SMTP;

#   $smtp = Net::SMTP->new('smtp.isp.net',
#                          Hello => 'smtp.isp.net',
#                            Timeout => 30,
#                            Debug => 1,
#                           ); # connect to an SMTP server
#    $smtp->mail( 'myemail@isp.net' );     # use the sender's address here
#    $smtp->to('myemail@isp.net');        # recipient's address
#    $smtp->data();                      # Start the mail

    # Send the header.
#    $smtp->datasend("To: myemail\@isp.net\n");
#    $smtp->datasend("From: myemail\@isp.net\n");
#    $smtp->datasend("\n");

    # Send the body.
#    $smtp->datasend("Hello, World5!\n");
#    $smtp->dataend();                   # Finish sending the mail
#    # The following indicates SMTP resolution... not xfer success.
#    print $smtp->domain,"\n";
#    $smtp->quit;                        # Close the SMTP connection
#}

sub mailkey {
    # Stub function. Currently we depend on Sendmail being installed.
    # Hook anything else you want (audio, SMS etc) here.
    
    # FIXME / TODO: Merge code with &mailip()
    &mailkeySendmail();
    #mailkeyPerl();

}

sub mailkeySendmail {
	
    if (-e "/usr/lib/sendmail") {		
            $mailpath = "/usr/lib/sendmail";
    } elsif (-e "/usr/sbin/sendmail") {
            $mailpath = "/usr/sbin/sendmail";
    } elsif (-e "/usr/bin/sendmail") {
            $mailpath = "/usr/bin/sendmail";
    }	

    open (MAIL, "| $mailpath $cluster\n");
    print MAIL "From: Linux Set Top Mailer <$usermail>\n";
    print MAIL "To: $cluster\n";
    print MAIL "Subject: Need TZO KEY\n";
    print MAIL "\n";
    print MAIL "Please Send a TZO Key\n";
    close (MAIL);
}

sub mailip {
    # FIXME / TODO: Merge with &mailkey()
	
    if (-e "/usr/lib/sendmail") {
            $mailpath = "/usr/lib/sendmail";
    } elsif (-e "/usr/sbin/sendmail") {
            $mailpath = "/usr/sbin/sendmail";
    } elsif (-e "/usr/bin/sendmail") {
            $mailpath = "/usr/bin/sendmail";
    }

    open (MAILip, "| $mailpath $mailipa\n");
    print MAILip "From: TZO DDNS LinuxPerl Client <$usermail>\n";
    print MAILip "To: $usermail\n";
    print MAILip "Subject: IP Address Changed\n";
    print MAILip "\n";
    print MAILip "Your IP Address has Updated on TZO DDNS.\n\n";
    print MAILip "Domain on TZO: $TZONAME\n\n";
    print MAILip "Your New IP Address: $IPADDRESS\n";
    close (MAILip);
}

sub verbose2 {
    # uncomment any of these using verbose output
    #print "$signwhat\n";
    #print "TZOEMAIL = [$TZOEMAIL]\n";
    #print "TZONAME = [$TZONAME]\n";
    #print "TZOKEY = [$TZOKEY]\n";
    #print "CTYPE = [$CTYPE]\n";
    #print "IPLOG = [$iplog]\n";
    #print "interface = [$interface]\n\n";
    #print "RemoteIP = [$remote_ip]\n\n"; # gateway address
    #print "IPADDRESS = [$IPADDRESS]\n";
    #print "CGIPATH = [$CGIPATH]\n";
    #print "iplog log file = [$iplog]\n";
    #print "\t\n\n$signwhat $TZONAME \n\n";
    #print "\tYour current ip on TZO DDNS is $TZOIP\n\n";
    print "\nDomain Name: $TZONAME\n";
    print "Email Address: $TZOEMAIL\n";
    print "Current IP Address: $TZOIP\n";
    print "Account Expiration Date: $TZO_EXPIRE\n\n\n";
    #print "\tYour TZO Name is $TZO_NAME\n";
    #print "\t$TZONAME expires on $TZO_EXPIRE (month/day/year)\n\n";
    #print "usage log file = [$usage]\n";
}



sub usage {
    print << "__EOS__"
        
        $0 [options] <-o|-f>
        
         -o             : signon to TZO
         -f             : signoff to TZO
         -d             : daemonize
         -q             : Quit the Daemon
        
        where options are:
        
         -h             : give usage.
         -v             : give some informative output.
         -e <TZO email> : specify TZO email (default: $TZOEMAIL )
         -n <TZO name>  : specify TZO name (default: $TZONAME )
         -k <TZO key>   : specify your TZO key (default: $TZOKEY )
         -i <interface> : get ip address from (default: $interface )
         -I <ipaddress> : use (default: $IPADDRESS ) 
         -c <ctype>     : specify connection type (default: $CTYPE )
                                
        
         CTYPE (Connection Types)
           1   Dial-up Modem
           2   Cable Modem
           3   LAN (Local Area Network)
           4   ADSL, HDSL, xDSL
           5   America Online Dial-up
           6   Other Connection Type
           7   Static IP Address
        
__EOS__
} #end &usage()

sub daemon {
	        
	chdir '/' or die "Can't chdir to /: $!";
	open STDIN, '/dev/null' or die "Can't read /dev/null: $!";
	open STDOUT, '>/dev/null' or die "Can't write to /dev/null: $!";
	open STDERR, '>/dev/null' or die "Can't write to /dev/null: $!";
	
	defined(my $pid = fork)
		or die "Can't fork: $!";
	exit if $pid;
	
	# Scott: Changed from setsid to setsid() to eliminate warning. retest?
	setsid() or die "Can't start a new session: $!";
	
	umask 0;
	    
}

sub handler {
	signofftzo();
	exit(0);
}

sub caught_int {
	$SIG{INT} = \&caught_int;
	$SIG{KILL} = \&caught_int;
	handler();
}

1;

